/////////////////////////////////////////////////////////////////////////////////
//
// BkMail.h
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: BkMail.h,v $
 * Revision 1.12  2000/11/07 15:57:17  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */


#pragma once
#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


/////////////////////////////////////////////////////////////////////////////////
//
#include <algorithm>
#include <functional>
#include <list>
#include "LineReader.h"
#include "tokenizer.h"
#include "b2mailstream.h"


/////////////////////////////////////////////////////////////////////////////////
//
using namespace std;

class BkMail;
typedef list<string > StringList;
typedef list<BkMail* > BkMailList;


/////////////////////////////////////////////////////////////////////////////////
//
/**
 * BkMultipartManager::find
 */
#define FINDMIMEITEM_CHILD                  0x00000001
#define FINDMIMEITEM_NEXT                   0x00000002
#define FINDMIMEITEM_FIRST_ONE              0x00000004
#define FINDMIMEITEM_SECOND_ONE             0x00000008
#define FINDMIMEITEM_FIRST_SOME             0x00000010
#define FINDMIMEITEM_SECOND_SOME            0x00000020
#define FINDMIMEITEM_FIRST_CHILD            0x00000041
#define FINDMIMEITEM_FIRST_NEXT             0x00000082
#define FINDMIMEITEM_DEFAULT                FINDMIMEITEM_FIRST_CHILD | \
                                            FINDMIMEITEM_FIRST_SOME | \
                                            FINDMIMEITEM_NEXT | \
                                            FINDMIMEITEM_SECOND_SOME
#define FINDMIMEITEM_UNDER_STAGE            FINDMIMEITEM_FIRST_CHILD   | \
                                            FINDMIMEITEM_FIRST_ONE | \
                                            FINDMIMEITEM_NEXT | \
                                            FINDMIMEITEM_SECOND_SOME


/////////////////////////////////////////////////////////////////////////////////
//
/**
 * class: BkMultipartManager
 */
class BkMultipartManager
{
public:
    // Constructer
    BkMultipartManager();
    virtual ~BkMultipartManager();

    // mime type
    virtual const string& getType() const { return type; }
    virtual const string& getSubtype() const { return subtype; }
    virtual const string& getBoundary() const { return boundary; }
    virtual void setType(const string& newType) { type = newType; }
    virtual void setSubtype(const string& newSubtype) { subtype = newSubtype; }
    virtual void setBoundary(const string& newBoundary) { boundary = newBoundary; }

    // multipart\
    BkMail* getChild() const;
    BkMail* getNext() const;
    BkMail* setChild(BkMail* newChild);
    BkMail* addChild(BkMail* newChild);
    BkMail* setNext(BkMail* newNext);

    // mime item
    virtual BkMailList::iterator find(const BkMail* item, const string& forType, const string& forSubtype, unsigned int flag);
    virtual BkMailList::iterator end() { return resultSearch.end(); }

protected:
    // Tree
    virtual void explore(const BkMail* item, const string& forType, const string& forSubtype, unsigned int flag);

private:
    string type;
    string subtype;
    string boundary;

    BkMail* child;
    BkMail* next;

    BkMailList resultSearch;
};


/////////////////////////////////////////////////////////////////////////////////
//
/**
 * class: BkMail
 * ̃NXBecky! Internet Mail version 2擾郁[\[XƂɁA
 * mime multipart itemPʂł̃[f[^s悤ɂĂB
 * 揼CMIMEItemՂɁASTLōč\zB
 */
class BkMail
{
public:
    // constructer
    BkMail() {}
    explicit BkMail(const string& initSource) { fromString(initSource); }
    virtual ~BkMail();

    // o
    virtual void fromString(const string& newSource, const string& boundaryParent="");
    virtual void fromString(LineReader& first, LineReader& last, const string& boundaryParent= "");
    virtual string toString() const;

    // multipart
    /** qp[g̎擾 @return qp[g*/
    virtual BkMail* getChild() const { return multipart.getChild(); }
    /** Zp[g̎擾 @return Zp[g*/
    virtual BkMail* getNext() const { return multipart.getNext(); }
    /** qp[g̊i[BÂqp[g͑Sč폜B@param in VKqp[g*/
    virtual BkMail* setChild(BkMail* newChild) { return multipart.setChild(newChild); }
    /** qp[g̒ǉBÂqp[ǧZp[gƂĊi[B@param in VKqp[g*/
    virtual BkMail* addChild(BkMail* newChild) { return multipart.addChild(newChild); }
    /** Zp[g̊i[BÂZp[g͑Sč폜B@param in VKZp[g*/
    virtual BkMail* setNext(BkMail* newNext) { return multipart.setNext(newNext); }

    // Content-Type擾
    virtual const string& getType() const { return multipart.getType(); }
    virtual const string& getSubtype() const { return multipart.getSubtype(); }
    virtual const string& getBoundary() const { return multipart.getBoundary(); }
    virtual bool isMime(const string& toType, const string& toSubtype);

    // mime item
    virtual BkMailList::iterator findMimeItem(const string& forType, const string& forSubtype, unsigned int flag)
        { return multipart.find(this, forType, forSubtype, flag); }
    virtual BkMailList::iterator end() { return multipart.end(); }

    // headerA͋@\t
    virtual string getHeader(const string& name);
    virtual void setHeader(const string& name, const string& data);

    // headers, body, trail
    virtual void pushHeaderFront(const string& data);
    virtual void pushHeaderBack(const string& data);
    virtual void clearHeader();
    virtual void pushBodyFront(const string& data);
    virtual void pushBodyBack(const string& data);
    virtual void clearBody();
    virtual void pushTrailFront(const string& data);
    virtual void pushTrailBack(const string& data);
    virtual void clearTrail();

    // attached rfc822 message
    virtual BkMail* getRfc822();

protected:
    // headers, body, trailANZT
    virtual StringList& getHeaders() { return headers; }
    virtual StringList& getBody() { return body; }
    virtual StringList& getTrail() { return trail; }

    // ̓[\[X
    virtual BkMail* createInstance() { return new BkMail(); }
    virtual void parseHeaders(LineReader& first, LineReader& last);
    virtual void parseBody(LineReader& first, LineReader& last, const string& boundary);
    virtual void connectHeaderLine(LineReader& first, LineReader& last, string& linebuf);
    virtual void parseContentType(const string& header);
    virtual bool getOption(string::iterator& begin, string::iterator& end, string& option, string& value);

private:
    StringList headers; // wb_̃Xg
    StringList body; // {̃XgiboundaryOj
    StringList trail; // {̃Xg(boundaryj

    BkMultipartManager multipart;
};


/////////////////////////////////////////////////////////////////////////////////
//
namespace std {
/**
 * functional: equal_to_break
 * Content-Typewb_̃IvVC̋؂蕶p̊֐IuWFNg
 */
template<class _Ty>
	struct equal_to_break : unary_function<_Ty, bool > {
	bool operator()(const _Ty& _X) const
		{return (_X == '\t' || _X == '\x20' || _X == ';' || _X == '\r' || _X == '\n'); }
	};


/**
 * functional: not_equal_to_break
 * Content-Typewb_̃IvVC̋؂蕶p̊֐IuWFNg
 */
template<class _Ty>
	struct not_equal_to_break : unary_function<_Ty, bool > {
	bool operator()(const _Ty& _X) const
		{return (_X != '\t' && _X != '\x20' && _X != ';' && _X != '\r' && _X != '\n'); }
	};


/**
 * functional: not_equal_to_lswp
 * wb_̋؂蕶p
 */
template<class _Ty>
	struct not_equal_to_lswp : unary_function<_Ty, bool > {
	bool operator()(const _Ty& _X) const
		{return (_X != '\t' && _X != '\x20' && _X != '\r' && _X != '\n'); }
	};

}


/////////////////////////////////////////////////////////////////////////////////
//
#include <locale>

template<class _E, class _Tr, class _A> inline
    basic_b2mailstream<_E, _Tr, _A>& __cdecl operator>>(
        basic_b2mailstream<_E, _Tr, _A>& _I,
        BkMail& _M)
    {typedef ctype<_E> _Ctype;
    typedef basic_istream<_E, _Tr> _Myis;
    basic_string<_E, _Tr, _A> _X;
    ios_base::iostate _St = ios_base::goodbit;
    bool _Chg = false;
    _X.erase();
    const _Myis::sentry _Ok(_I);
    if (_Ok)
        {const _Ctype& _Fac = _USE(_I.getloc(), _Ctype);
        try {
        _A::size_type _N = 0 < _I.width()
            && _I.width() < (signed) _X.max_size()
                ? _I.width() : _X.max_size();
        _Tr::int_type _C = _I.rdbuf()->sgetc();
        for (; 0 < --_N; _C = _I.rdbuf()->snextc())
            {if(_Tr::eq_int_type(_Tr::eof(), _C))
                {_St |= ios_base::eofbit;
                break; }
            else
                {_X.append(1, _Tr::to_char_type(_C));
                _Chg = true; }}}
        catch (...)
            { }}
    _I.width(0);
    if (!_Chg)
        _St |= ios_base::failbit;
    _I.setstate(_St);
    _M.fromString(_X);
    return (_I); }


template<class _E, class _Tr, class _A> inline
    basic_b2mailstream<_E, _Tr, _A>& __cdecl operator<<(
        basic_b2mailstream<_E, _Tr, _A>& _O,
        const BkMail& _X)
    {
    _O << _X.toString().c_str();
    return (_O); }


#ifdef _DLL
#pragma warning(disable:4231) // the extern before template is a non-standard extension

extern template class _CRTIMP
    b2mailstream& __cdecl operator>>(b2mailstream& _I, BkMail& _M, allocator<char> >&);
extern template class _CRTIMP
    b2mailstream& __cdecl operator>>(b2mailstream& _O, const BkMail& _M, allocator<char> >&);

#pragma warning(default:4231) // restore previous warning
#endif      // _DLL


/////////////////////////////////////////////////////////////////////////////////
//
#pragma warning(pop) /* restore previous warning */
