

#pragma once


#include <winbase.h>


class CriticalSection
{
public:
    CriticalSection();
    virtual ~CriticalSection();

    void enter();
    void leave();

    CRITICAL_SECTION *getCriticalSection();

private:
    CRITICAL_SECTION critsec;
};


inline CriticalSection::CriticalSection()
{
    ::InitializeCriticalSection(&critsec);
}


inline CriticalSection::~CriticalSection()
{
    ::DeleteCriticalSection(&critsec);
}


inline void CriticalSection::enter()
{
    ::EnterCriticalSection(&critsec);
}


inline void CriticalSection::leave()
{
    ::LeaveCriticalSection(&critsec);
}