

/////////////////////////////////////////////////////////////////////////////////
//    
#include "PGPlog.h"


/////////////////////////////////////////////////////////////////////////////////
//    
PGPlog* PGPlog::_instance = NULL;
CriticalSection PGPlog::_critsec;
long PGPlog::_counter = 0;


/////////////////////////////////////////////////////////////////////////////////
//    
PGPlog::PGPlog()
{
    bool result = false;
    do {
        pgpsc_instance = LoadLibrary("PGPSC.DLL");
        if (pgpsc_instance < reinterpret_cast<HINSTANCE>(HINSTANCE_ERROR)) {
            pgpsc_instance = NULL;
            return;
        }
        if (!((FARPROC&)SendPGPlogMsg = GetProcAddress(pgpsc_instance, "SendPGPlogMsg"))) break;
        result = true;
    } while (0);

    if (!result) {
        pgpsc_instance = NULL;
    }
}


PGPlog::~PGPlog()
{
	if (pgpsc_instance) {
		FreeLibrary(pgpsc_instance);
	}
    _instance = NULL;
}


PGPlog* PGPlog::Instance()
{
    _critsec.enter();

    InterlockedIncrement(&_counter);
    if (_instance == NULL) {
        _instance = new PGPlog();
    }

    if (_instance->pgpsc_instance == NULL) {
        delete _instance;
        _instance = NULL;
    }

    _critsec.leave();

    return _instance;
}


void PGPlog::Release()
{
    _critsec.enter();

    if (InterlockedDecrement(&_counter) == 0) {
        delete _instance;
    }

    _critsec.leave();
}

bool PGPlog::setLogMessage(HWND hwnd, char *mes)
{
    if (!pgpsc_instance) {
        return false;
    }
    return (SendPGPlogMsg(hwnd, mes) == TRUE);
}