/////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2Thread.cpp
//
// Copyright(C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2Thread.cpp,v $
 * Revision 1.3  2000/11/23 07:17:58  syou
 * - DllMainŎqXbh쐬Ă߁APGPB2[hĂȂԂŁA
 *   B2̃vOC̑I_CAOJƂAB2ƂɗĂ
 *   oOCBWindows98ŏ؂̃bZ[WpƂȂĂ̂C
 *   BlXg`ɂȂĂPGP/MIME[̕ƌ؂肭oȂ
 *   oOPgpb2::decodePgpMailPartPgpb2::decodePgpMailPart2ŏCB
 *   Decode܂̃WbŇccłB
 *   PGP/MIMEbZ[W̕ƌ؋@\ǉB،ʂɂẮAƂ肠
 *   PGPlogɕ\悤ɂ݂܂Bo̓bZ[W\[X֒ǕB
 *
 * Revision 1.2  2000/11/08 16:50:47  syou
 * - PGPlogɃbZ[Wo͂邽߂ɁAclass PGPlogVK쐬B
 *   FXKvɂȂ肻Ȃ̂ŁAclass CriticalSectionVK쐬B
 *
 * Revision 1.1  2000/11/07 15:57:19  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 *
 */


#include "Pgpb2Thread.h"


/////////////////////////////////////////////////////////////////////////////////
//
DWORD Pgpb2Thread::tlsid = 0;

/////////////////////////////////////////////////////////////////////////////////
//
Pgpb2Thread::Pgpb2Thread(HINSTANCE initInstance, DWORD initTlsid)
    : pgpb2(initInstance)
{
    instance = initInstance;
    tlsid = initTlsid;
    enter = TRUE;
    context = kInvalidPGPContextRef;
    threadid = NULL;
}


Pgpb2Thread::~Pgpb2Thread()
{
    if (tlsid != TLS_OUT_OF_INDEXES) {
        initTls(NULL);
    }
}


bool Pgpb2Thread::run()
{
    threadid = _beginthread(Pgpb2Thread::threadStart, 0, this);
    return (threadid != -1);
}


void Pgpb2Thread::threadStart(void* threadObject)
{
    Pgpb2Thread* pgpb2Thread = static_cast<Pgpb2Thread*>(threadObject);
    pgpb2Thread->main();
}


void Pgpb2Thread::main()
{
    MSG msg;
    registerWindowClass();
    if (initTls(this) && initPGPContext() && initWindow())
    {
        while(GetMessage(&msg, NULL, 0, 0))
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
    }
}


ATOM Pgpb2Thread::registerWindowClass()
{
    WNDCLASSEX wcex;

    wcex.cbSize         = sizeof(WNDCLASSEX);
    wcex.style          = 0;//CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc    = (WNDPROC)Pgpb2Thread::WndProc;
    wcex.cbClsExtra     = 0;
    wcex.cbWndExtra     = 0;
    wcex.hInstance      = instance;
    wcex.hIcon          = 0;//LoadIcon(hInstance, (LPCTSTR)IDI_TESTES);
    wcex.hCursor        = 0;//LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground  = 0;//(HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName   = 0;//(LPCSTR)IDC_TESTES;
    wcex.lpszClassName  = "PGPB2HIDECLASS";
    wcex.hIconSm        = 0;//LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

    return RegisterClassEx(&wcex);
}


bool Pgpb2Thread::initTls(Pgpb2Thread* pointer)
{
    return (TlsSetValue(tlsid, pointer) == TRUE);
}


bool Pgpb2Thread::initWindow()
{
   windowOfPgpb2 = CreateWindow("PGPB2HIDECLASS", 0, 0, 0, 0, 0, 0, NULL, NULL, instance, NULL);
   if(!windowOfPgpb2)
   {
      return false;
   }

   ShowWindow(windowOfPgpb2, SW_HIDE);
   return true;
}


void Pgpb2Thread::stop()
{
    SendMessage(windowOfPgpb2, WM_DESTROY, 0, 0);
}


LRESULT CALLBACK Pgpb2Thread::WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    Pgpb2Thread* pgpb2Thread = static_cast<Pgpb2Thread*>(TlsGetValue(tlsid));
    if (pgpb2Thread) {
        return pgpb2Thread->windowProc(hWnd, msg, wParam, lParam);
    }
    return DefWindowProc(hWnd, msg, wParam, lParam);
}


LRESULT Pgpb2Thread::windowProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg)
    {
        case WM_DESTROY:
            PostQuitMessage(0);
            break;
        case WM_PGPB2_ENCRYPT:
            {
                bool encode = pgpb2.encrypt(recipentWindow, context);
                PgpMail *mail = pgpb2.getMail();
                if (encode && pgpb2.isPgpmime()) {
                    SendMessage(recipentWindow, WM_COMMAND,
                        message[PGPB2_COMPSETSOURCE], 0);
                }
                else if (encode) {
                    SendMessage(recipentWindow, WM_COMMAND,
                        message[PGPB2_COMPSETTEXT], 0);
                }
                delete mail;
                InterlockedExchange(&enter, TRUE);
                EnableWindow(recipentWindow, PGPB2_ENTERTRUE);
            }
            break;
        case WM_PGPB2_SIGINING:
            {
                bool encode = pgpb2.signing(recipentWindow, context);
                PgpMail *mail = pgpb2.getMail();
                if (encode && pgpb2.isPgpmime()) {
                    SendMessage(recipentWindow, WM_COMMAND,
                        message[PGPB2_COMPSETSOURCE], 0);
                }
                else if (encode) {
                    SendMessage(recipentWindow, WM_COMMAND,
                        message[PGPB2_COMPSETTEXT], 0);
                }
                delete mail;
                InterlockedExchange(&enter, PGPB2_ENTERTRUE);
                EnableWindow(recipentWindow, TRUE);
            }
            break;
        case WM_PGPB2_ENCRYPTSIGINING:
            {
                bool encode = pgpb2.encryptSigning(recipentWindow, context);
                PgpMail *mail = pgpb2.getMail();
                if (encode && pgpb2.isPgpmime()) {
                    SendMessage(recipentWindow, WM_COMMAND,
                        message[PGPB2_COMPSETSOURCE], 0);
                }
                else if (encode) {
                    SendMessage(recipentWindow, WM_COMMAND,
                        message[PGPB2_COMPSETTEXT], 0);
                }
                delete mail;
                InterlockedExchange(&enter, PGPB2_ENTERTRUE);
                EnableWindow(recipentWindow, TRUE);
            }
            break;/*
        case WM_PGPB2_PUBLICKEY:
            {
                //pgpb2.publickey();
                PgpMail *mail = pgpb2.getMail();
                if (pgpb2.didEncode()) {
                    SendMessage(recipentWindow, WM_COMMAND,
                        message[PGPB2_SETSOURCE], 0);
                }
                delete mail;
                InterlockedExchange(&enter, PGPB2_ENTERTRUE);
                EnableWindow(recipentWindow, TRUE);
            }
            break;//*/
        case WM_PGPB2_DECODEPGPMIME:
            {
                bool decode = pgpb2.decodePgpMime(recipentWindow, context);
                PgpMail *mail = pgpb2.getMail();
                if (decode) {
                    SendMessage(recipentWindow, WM_COMMAND,
                        message[PGPB2_SETTEMPSOURCE], 0);
                }
                delete mail;
                InterlockedExchange(&enter, PGPB2_ENTERTRUE);
                EnableWindow(recipentWindow, TRUE);
            }
            break;
        case WM_PGPB2_DECODENOTPGPMIME:
            {
                bool decode = pgpb2.decodeNotPgpMime(recipentWindow, context);
                PgpMail *mail = pgpb2.getMail();
                if (decode) {
                    SendMessage(recipentWindow, WM_COMMAND,
                        message[PGPB2_SETTEMPTEXT], 0);
                }
                delete mail;
                InterlockedExchange(&enter, PGPB2_ENTERTRUE);
                EnableWindow(recipentWindow, TRUE);//*/
            }
            break;
        default:
            return DefWindowProc(hWnd, msg, wParam, lParam);
   }
   return 0;
}


bool Pgpb2Thread::initPGPContext()
{
    context = kInvalidPGPContextRef;
    PGPError err = PGPNewContext(kPGPsdkAPIVersion, &context);
    if(IsPGPError(err)) {
        return false;
    }
    return true;
}


void Pgpb2Thread::setRecipientWindow(HWND newRecipentWindow)
{
    recipentWindow = newRecipentWindow;
}


MessageMap& Pgpb2Thread::getMessageMap()
{
    return message;
}


/**
 * Í
 */
bool Pgpb2Thread::pgpEncrypt(HWND hWnd, PgpMail* mail)
{
    if (InterlockedExchange(&enter, PGPB2_ENTERFALSE) != PGPB2_ENTERTRUE) {
        return false;
    }
    EnableWindow(hWnd, FALSE);
    setRecipientWindow(hWnd);
    pgpb2.setMail(mail);
    PostMessage(windowOfPgpb2, WM_PGPB2_ENCRYPT, 0, 0);
    Sleep(0);
    return true;
}


/**
 * 
 */
bool Pgpb2Thread::pgpSigning(HWND hWnd, PgpMail* mail)
{
    if (InterlockedExchange(&enter, PGPB2_ENTERFALSE) != PGPB2_ENTERTRUE) {
        return false;
    }
    EnableWindow(hWnd, FALSE);
    setRecipientWindow(hWnd);
    pgpb2.setMail(mail);
    PostMessage(windowOfPgpb2, WM_PGPB2_SIGINING, 0, 0);
    return true;
}


/**
 * ÍƏ
 */
bool Pgpb2Thread::pgpEncryptSigning(HWND hWnd, PgpMail* mail)
{
    if (InterlockedExchange(&enter, PGPB2_ENTERFALSE) != PGPB2_ENTERTRUE) {
        return false;
    }
    EnableWindow(hWnd, FALSE);
    setRecipientWindow(hWnd);
    pgpb2.setMail(mail);
    PostMessage(windowOfPgpb2, WM_PGPB2_ENCRYPTSIGINING, 0, 0);
    return true;
}


/**
 * JYt
 *//*
bool Pgpb2Thread::pgpPublickey(HWND hWnd, PgpMail* mail)
{
    if (enter == PGPB2_ENTERFALSE) {
        return false;
    }
    InterlockedExchange(&enter, PGPB2_ENTERFALSE);
    EnableWindow(hWnd, FALSE);
    setRecipientWindow(hWnd);
    pgpb2.setMail(mail);
    PostMessage(windowOfPgpb2, WM_PGPB2_PUBLICKEY, 0, 0);
    return true;
}
//*/

/**
 * ƌ
 */
bool Pgpb2Thread::pgpDecodePgpMime(HWND hWnd, PgpMail* mail)
{
    if (InterlockedExchange(&enter, PGPB2_ENTERFALSE) != PGPB2_ENTERTRUE) {
        return false;
    }
    EnableWindow(hWnd, FALSE);
    setRecipientWindow(hWnd);
    pgpb2.setMail(mail);
    PostMessage(windowOfPgpb2, WM_PGPB2_DECODEPGPMIME, 0, 0);
    return true;
}


/**
 * ƌ؂͂ǂ낤H
 */
bool Pgpb2Thread::pgpDecodeNotPgpMime(HWND hWnd, PgpMail* mail)
{
    if (InterlockedExchange(&enter, PGPB2_ENTERFALSE) != PGPB2_ENTERTRUE) {
        return false;
    }
    EnableWindow(hWnd, FALSE);
    setRecipientWindow(hWnd);
    pgpb2.setMail(mail);
    PostMessage(windowOfPgpb2, WM_PGPB2_DECODENOTPGPMIME, 0, 0);
    return true;
}
//*/

/////////////////////////////////////////////////////////////////////////////////
//
