////////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2Utility.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2Utility.cpp,v $
 * Revision 1.2  2000/11/07 15:57:20  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 * Revision 1.1  2000/08/06 15:14:42  syou
 * - message/rfc822`Ń[YtĂꍇAYtĂ郁[
 *   ǂ̑ΏۂƂȂ悤ɂBB2(beta23)ȍ~ep[g Content-Typew
 *   ƎQƂ邱ƂmFBAbeta22ȑOgč쐬ꂽ
 *   multipart[̏ꍇ́Â肭Ȃ悤ɎvB
 *   main.cpp剻߁ABclass CPgpb2ǉA
 *   Pgpb2Decode.cppAPgpb2Encode.cppAPgpb2Utility.cppɕčsB
 *   剻ABkMail.h𕪊Bclass`BkMessage.hɏWA
 *   class CBkMessagẽCC֐BkMessage.hɁAclass CBkMailPart̃C
 *   C֐BkMailPart.hɁAclass CBkMail̃CC֐BkMail.hɋL
 *   qA#includeɂABkMessage.h̖Ɏ荞łB
 *   ȊÓAꂼBkMessage.cppABkMailPart.cppABkMail.cppɎB
 *   message/rfc822`̓Yt[ɑΉ邽߁A class CBkRfc822ǉBC
 *   C֐ BkRfc822.hɋLqȂBkRfc822.cppɎBclass
 *   CBkMessage̔hNXÂNXłclass
 *   CBkMessageɈϏB
 *   Encodẽ[`̕ADecodê̂ɓB܂A
 *         CBkMailPartPtr apEncrypt1;
 *         apEncrypt1 = mail.SetChild(new CMIMEItem());
 *
 */


#include "Pgpb2.h"


////////////////////////////////////////////////////////////////////////
// Utility
int Pgpb2::addAddressList(CPointerList& plstAddr, const string& toccbcc)
{
    char szName[256]; // oOi֐spj
    char szEMail[256]; // o[AhX
    char szUserID[260]; // [UID
    int size = 0;
    LPSTR lpTok; // ؂oACe
    LPSTR lpToCcBcc = b2api->SerializeRcpts(toccbcc.c_str());
    lpTok = TokenAddr(lpToCcBcc);
    while (lpTok) {
        GetNameAndAddr(szName, 256, szEMail, 256, lpTok);
        sprintf(szUserID, "%s", szEMail);
        plstAddr.AddTail(szUserID);
        size += strlen(szUserID) + 2; // u[UID̒+2vZ
        lpTok = TokenAddr(NULL);
    }
    b2api->Free(lpToCcBcc);
    return size;
}


bool Pgpb2::getKeySet(CPointerItem* pItem, PGPContextRef context, PGPKeySetRef& foundUserKeys)
{
    PGPKeySetRef defaultKeyRing = NULL;
    PGPError err = PGPOpenDefaultKeyRings(context, kPGPKeyRingOpenFlags_Mutable, &defaultKeyRing);
    if (IsPGPError(err)) {
        return FALSE;
    }

    PGPFilterRef filter = NULL;
    PGPFilterRef newFilter = NULL;
    PGPFilterRef oldFilter = NULL;
    while (pItem) {
        LPSTR lpStr = pItem->GetData();
        if (filter == NULL) {
            err = PGPNewUserIDEmailFilter(context, lpStr, kPGPMatchEqual, &filter);
            if (IsPGPError(err)) {
                return FALSE;
            }
        }
        else {
            err = PGPNewUserIDEmailFilter(context, lpStr, kPGPMatchEqual, &newFilter);
            if (IsPGPError(err)) {
                return FALSE;
            }
            err = PGPUnionFilters(oldFilter, newFilter, &filter);
            if (IsPGPError(err)) {
                return FALSE;
            }
        }
        oldFilter = filter;
        pItem = pItem->GetNext();
    }

    err = PGPFilterKeySet(defaultKeyRing, filter, &foundUserKeys);
    if (IsPGPError(err)) {
        return FALSE;
    }

    if(PGPKeySetRefIsValid(defaultKeyRing)) {
        PGPFreeKeySet(defaultKeyRing);
    }

    if(PGPFilterRefIsValid(filter)) {
        PGPFreeFilter(filter);
    }

    return TRUE;
}


BOOL Pgpb2::getHashAlgorithm(PGPKeyRef& signingKey, LPSTR lpHash)
{
    if (lpHash == NULL) {
        return FALSE;
    }

    PGPHashAlgorithm hashAlg;
    PGPError err = PGPGetHashAlgUsed(signingKey, &hashAlg);
    if (IsPGPError(err)) {
        return FALSE;
    }

    switch (hashAlg) {
    case kPGPHashAlgorithm_Invalid:
        return FALSE;
    case kPGPHashAlgorithm_MD5:
        strcpy(lpHash, "md5");
        break;
    case kPGPHashAlgorithm_SHA:
        strcpy(lpHash, "sha1");
        break;
    case kPGPHashAlgorithm_RIPEMD160:
        strcpy(lpHash, "ripemd160");
        break;
    default:
        return FALSE;
    }

    return TRUE;
}


